import firebase from 'firebase/app';
import { SignData, UserCredentials } from 'entropic-bond';
import { AuthService } from 'entropic-bond';
export declare class FirebaseAuth extends AuthService<firebase.auth.UserCredential> {
    constructor();
    signUp(signData: SignData): Promise<UserCredentials>;
    login(signData: SignData): Promise<UserCredentials>;
    logout(): Promise<void>;
    onAuthStateChange(onChange: (userCredentials: UserCredentials) => void): void;
    private toUserCredentials;
    static convertCredentials(nativeUserCredential: firebase.User, claims: {
        [key: string]: any;
    }): UserCredentials;
    private registerCredentialProviders;
}
