"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var FirebaseCloudStorage_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseCloudStorage = void 0;
const entropic_bond_1 = require("entropic-bond");
const firebase_helper_1 = require("../firebase-helper");
let FirebaseCloudStorage = FirebaseCloudStorage_1 = class FirebaseCloudStorage extends entropic_bond_1.CloudStorage {
    constructor(emulator) {
        super();
        if (emulator)
            firebase_helper_1.FirebaseHelper.useEmulator(emulator);
        const { emulate, host, storagePort } = firebase_helper_1.FirebaseHelper.emulator;
        if (emulate) {
            firebase_helper_1.FirebaseHelper.instance.storage().useEmulator(host, storagePort);
        }
    }
    store(id, data) {
        const storage = firebase_helper_1.FirebaseHelper.instance.storage();
        return new Promise((resolve, reject) => {
            this._uploadTask = storage.ref().child(id).put(data);
            this._uploadTask
                .then(() => resolve(id))
                .catch(error => reject(error));
        });
    }
    getUrl(reference) {
        if (!reference)
            return Promise.resolve(undefined);
        const storage = firebase_helper_1.FirebaseHelper.instance.storage();
        return storage.ref().child(reference).getDownloadURL();
    }
    uploadControl() {
        return {
            cancel: () => this._uploadTask.cancel(),
            pause: () => this._uploadTask.pause(),
            resume: () => this._uploadTask.resume(),
            onProgress: (callback) => this._uploadTask.on('state_changed', snapShot => {
                if (callback) {
                    callback(snapShot.bytesTransferred, snapShot.totalBytes);
                }
            })
        };
    }
    delete(reference) {
        const storage = firebase_helper_1.FirebaseHelper.instance.storage();
        return storage.ref().child(reference).delete();
    }
};
FirebaseCloudStorage = FirebaseCloudStorage_1 = __decorate([
    entropic_bond_1.registerCloudStorage('FirebaseCloudStorage', () => new FirebaseCloudStorage_1())
], FirebaseCloudStorage);
exports.FirebaseCloudStorage = FirebaseCloudStorage;
//# sourceMappingURL=firebase-cloud-storage.js.map