import firebase from "firebase";
import "firebase/auth";
import "firebase/firestore";
import "firebase/storage";
export declare type FirebaseQuery = firebase.firestore.CollectionReference<firebase.firestore.DocumentData> | firebase.firestore.Query<firebase.firestore.DocumentData>;
export interface FirebaseConfig {
    apiKey?: string;
    authDomain?: string;
    projectId: string;
    databaseURL?: string;
    storageBucket?: string;
    messagingSenderId?: string;
    appId?: string;
}
export interface EmulatorConfig {
    host?: string;
    firestorePort?: number;
    storagePort?: number;
    authPort?: number;
    emulate?: boolean;
}
export declare class FirebaseHelper {
    static setFirebaseConfig(config: FirebaseConfig): void;
    static useEmulator(emulatorConfig?: EmulatorConfig): void;
    static get emulator(): EmulatorConfig;
    private constructor();
    static get instance(): FirebaseHelper;
    firestore(): firebase.firestore.Firestore;
    storage(): firebase.storage.Storage;
    auth(): firebase.auth.Auth;
    private static _instance;
    private static _firebaseConfig;
    private static _emulatorConfig;
}
