"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseHelper = void 0;
const firebase_1 = __importDefault(require("firebase"));
require("firebase/auth");
require("firebase/firestore");
require("firebase/storage");
class FirebaseHelper {
    constructor() {
        if (!FirebaseHelper._firebaseConfig)
            throw new Error('You should set a firebase config object before using Firebase');
        firebase_1.default.initializeApp(FirebaseHelper._firebaseConfig);
    }
    static setFirebaseConfig(config) {
        FirebaseHelper._firebaseConfig = config;
    }
    static useEmulator(emulatorConfig) {
        const defaultConfig = {
            host: 'localhost',
            firestorePort: 8080,
            storagePort: 9199,
            authPort: 9099,
            emulate: true
        };
        this._emulatorConfig = Object.assign(Object.assign({}, defaultConfig), emulatorConfig);
    }
    static get emulator() {
        return this._emulatorConfig;
    }
    static get instance() {
        return this._instance || (this._instance = new FirebaseHelper());
    }
    firestore() {
        return firebase_1.default.firestore();
    }
    storage() {
        return firebase_1.default.storage();
    }
    auth() {
        return firebase_1.default.auth();
    }
}
exports.FirebaseHelper = FirebaseHelper;
//# sourceMappingURL=firebase-helper.js.map