import { Collections, DataSource, DocumentObject, QueryObject } from 'entropic-bond';
import { EmulatorConfig } from '../firebase-helper';
export declare class FirebaseDatasource extends DataSource {
    constructor(emulator?: EmulatorConfig);
    findById(id: string, collectionName: string): Promise<DocumentObject>;
    save(collections: Collections): Promise<void>;
    find(queryObject: QueryObject<DocumentObject>, collectionName: string): Promise<DocumentObject[]>;
    delete(id: string, collectionName: string): Promise<void>;
    next(limit?: number): Promise<DocumentObject[]>;
    private getFromQuery;
    private _lastDocRetrieved;
    private _lastQuery;
    private _lastLimit;
}
