"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.snakeCase = exports.camelCase = exports.replaceValue = void 0;
function replaceValue(text, values) {
    if (!text)
        return '';
    return text.replace(/\${\s*(\w*)\s*}/g, function (_match, group) {
        return values[group] || '';
    });
}
exports.replaceValue = replaceValue;
function camelCase(str) {
    return str.replace(/([-_][\w])/g, group => group.toUpperCase().replace('-', '').replace('_', ''));
}
exports.camelCase = camelCase;
function snakeCase(str, snakeChar = '-') {
    return str[0].toLocaleLowerCase() + str.slice(1).replace(/([A-Z])/g, g => snakeChar + g[0].toLowerCase());
}
exports.snakeCase = snakeCase;
//# sourceMappingURL=utils.js.map